<?php

/**
 * @module          Canonical
 * @author          cms-lab
 * @copyright       2017-2018 cms-lab
 * @link            http://www.cms-lab.com
 * @license         custom license: http://cms-lab.com/_documentation/canonical/license.php
 * @license_terms   please see license
 *
 */

class canonical extends LEPTON_abstract
{
	public $pages = array();
	public $modified_pages = array();	
	public $database = 0;
	public $admin = 0;
	public $addon_color = 'blue';
	public $support_link = "<a href=\"#\">NO Live-Support / FAQ</a>";
	public $readme_link =  "<a href=\"http://cms-lab.com/_documentation/canonical/readme.php \" class=\"info\"target=\"_blank\">Readme</a>";
	public $action_url = ADMIN_URL . '/admintools/tool.php?tool=canonical';	

	public static $instance;

	public function initialize() 
	{
		$this->database = LEPTON_database::getInstance();		
		$this->init_tool();
//		$this->admin = LEPTON_admin::getInstance('admintools', 'admintools', false);	
	}
	
	public function init_tool( $sToolname = '' )
	{
		//get all pages
		$this->pages = array();
		$this->database->execute_query(
			"SELECT page_id, page_title, menu_title FROM ".TABLE_PREFIX."pages ORDER BY page_id " ,
			true,
			$this->pages,
			true
		);		

		//get all modified pages
		$this->modified_pages = array();
		$this->database->execute_query(
			"SELECT * FROM ".TABLE_PREFIX."mod_canonical ORDER BY page_id " ,
			true,
			$this->modified_pages,
			true
		);

		//get all not modified pages 
		$this->not_modified_pages = array();
		foreach( $this->pages as $display_page) {
			$found = false;
			foreach($this->modified_pages as $test_page) {
				if($test_page['page_id'] == $display_page['page_id'] ) {
					$found = true;
					break;
				}
			}
			if($found == false) {
				$this->not_modified_pages[] = $display_page;
			}
		}			
	}

} // end of class
?>