<?php

/**
 * @module          Canonical
 * @author          cms-lab
 * @copyright       2017-2018 cms-lab
 * @link            http://www.cms-lab.com
 * @license         custom license: http://cms-lab.com/_documentation/canonical/license.php
 * @license_terms   please see license
 *
 */

class canonical_functions extends canonical
{

    public static $instance;

public function initialize() 
	{	
		parent::initialize();
		$this->admin = LEPTON_admin::getInstance();
	}	
	
    public function list_pages() 
	{
		// delete obsolete entries
		foreach ($this->modified_pages as $existing) {
			if($this->database->get_one("SELECT page_id FROM ".TABLE_PREFIX."pages WHERE page_id = ".$existing['page_id']." ") == NULL) {
				$this->database->simple_query("DELETE FROM ".TABLE_PREFIX."mod_canonical WHERE page_id = ".$existing['page_id']."");		
			}
		}	

		// data for twig template engine	
		$data = array(
			'oCF'			=> $this,			
			'readme_link'	=> "http://cms-lab.com/_documentation/canonical/readme.php",	
			'leptoken'		=> get_leptoken()		

			);

		/**	
		 *	get the template-engine.
		 */
		$oTwig = lib_twig_box::getInstance();
		$oTwig->registerModule('canonical');
			
		echo $oTwig->render( 
			"@canonical/list.lte",	//	template-filename
			$data						//	template-data
		);
	
	}	

    public function show_info() 
	{
		// data for twig template engine	
		$data = array(
			'oCF'			=> $this,
			'image_url'		=> 'http://cms-lab.com/_documentation/media/canonical/canonical.jpg'
			);

		/**	
		 *	get the template-engine.
		 */
		$oTwig = lib_twig_box::getInstance();
		$oTwig->registerModule('canonical');
			
		echo $oTwig->render( 
			"@canonical/info.lte",	//	template-filename
			$data						//	template-data
		);		
		
	}

function save_link($id) 
	{
		if ( $id == 'entry') 
		{
			if( ($_POST['save_entry'] == 'cancel') || ($_POST['page_id'] == '') ) {
				header("Location: ".ADMIN_URL."/admintools/tool.php?tool=canonical&leptoken=".$_POST['leptoken']."");
				exit(0);	
			}			

			if( ($_POST['save_entry'] == 'save') && ($_POST['page_id'] != '') ) {
				
				$existing_id = $this->database->get_one("SELECT page_id FROM ".TABLE_PREFIX."mod_canonical WHERE page_id=".$_POST['page_id']."");
				if($existing_id != NULL){
					header("Location: ".ADMIN_URL."/admintools/tool.php?tool=canonical&leptoken=".$_POST['leptoken']."");
					exit(0);
				} else {
					// insert values
					$values = array();
					$this->database->execute_query(
						"SELECT * FROM ".TABLE_PREFIX."pages WHERE page_id=".$_POST['page_id']." " ,
						true,
						$values,
						false
					);				
					$this->database->simple_query("INSERT INTO ".TABLE_PREFIX."mod_canonical VALUES (NULL, ".$values['page_id'].", '".$values['page_title']."', '".$values['menu_title']."', '".LEPTON_URL."')");
						
					// Check if there is a db error, else success
					if($this->database->is_error()) {
					$this->admin->print_error($this->database->get_error());
					} else {
					$this->admin->print_success($this->language['record_saved'], ADMIN_URL."/admintools/tool.php?tool=canonical");
					}
				}
				
			}

			// Print admin footer
			$this->admin->print_footer();
		}
		
		if ( $id == 'link') 
		{
			if( ($_POST['save_link'] == 'cancel') || ($_POST['new_url'] == '') ) {
				header("Location: ".ADMIN_URL."/admintools/tool.php?tool=canonical&leptoken=".$_POST['leptoken']."");
				exit(0);	
			}

			if(isset ($_POST['save_link']) && is_numeric ($_POST['save_link']) ) {
				
				$this->database->simple_query("UPDATE ".TABLE_PREFIX."mod_canonical SET new_url = '".$_POST['new_url']."' WHERE id = ".$_POST['save_link']."  ");
						
				// Check if there is a db error, else success
				if($this->database->is_error()) {
					$this->admin->print_error($this->database->get_error());
				} else {
					$this->admin->print_success($this->language['record_saved'], ADMIN_URL."/admintools/tool.php?tool=canonical");
				}
			}

			// Print admin footer
			$this->admin->print_footer();		
		}
	}
	
function edit_link($id) 
	{
		if ( $id == 'new') 
		{
			// data for twig template engine	
			$data = array(
				'oCF'			=> $this,					
				'leptoken'		=> get_leptoken()					
				);

			/**	
			 *	get the template-engine.
			 */
			$oTwig = lib_twig_box::getInstance();
			$oTwig->registerModule('canonical');
				
			echo $oTwig->render( 
				"@canonical/add.lte",	//	template-filename
				$data							//	template-data
			);			
		}		

		if ( $id == 'edit') 
		{
			
			if(isset ($_POST['edit_link']) && is_numeric ($_POST['edit_link']) ) {
			$edit_id = $_POST['edit_link'];
			}

			$current = $this->database->get_one("SELECT new_url FROM ".TABLE_PREFIX."mod_canonical WHERE id = ".$edit_id." ")	;	
			
			// data for twig template engine	
			$data = array(
				'oCF'			=> $this,			
				'current_url'	=> $current,
				'current_id'	=> $edit_id,
				'leptoken'		=> get_leptoken()		
				);

			/**	
			 *	get the template-engine.
			 */
			$oTwig = lib_twig_box::getInstance();
			$oTwig->registerModule('canonical');
				
			echo $oTwig->render( 
				"@canonical/edit.lte",	//	template-filename
				$data					//	template-data
			);
		}
	}

function delete_link() 
	{
		if(isset ($_POST['delete_link']) && is_numeric ($_POST['delete_link']) ) {
			$to_delete = $_POST['delete_link'];
		}
		
		$this->database->simple_query("DELETE FROM ".TABLE_PREFIX."mod_canonical WHERE id = '".$to_delete."'");		
		
		// Check if there is a db error, else success
		if($this->database->is_error()) {
			$this->admin->print_error($this->database->get_error());
		} else {
			$this->admin->print_success($this->language['record_deleted'], ADMIN_URL.'/admintools/tool.php?tool=canonical');
		}

		// Print admin footer
		$this->admin->print_footer();	
	}
	
} // end of class
?>